package cn.com.qmth.stmms.biz.report.dao;

import cn.com.qmth.stmms.biz.report.model.ReportSubjectGroup;

import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * 大题成绩分析 Dao
 *
 * @author xuwenjin
 * @date 2019-04-18
 */
public interface ReportSubjectGroupDao extends PagingAndSortingRepository<ReportSubjectGroup, Integer>,
        JpaSpecificationExecutor<ReportSubjectGroup> {

    @Modifying
    @Query("delete from ReportSubjectGroup r where r.examId=?1 ")
    void deleteByExamId(Integer exmaId);

    @Query("select q.mainNumber,q.mainTitle,q.paperType,count(q.mainNumber) as subNumber ,sum(q.totalScore) as mainTotalScore "
            + " from ExamQuestion q where q.examId=?1 and q.subjectCode=?2 and q.objective=?3 group by q.mainNumber,q.mainTitle,q.paperType  "
            + " order by q.mainNumber")
    public List<Object[]> countGroupByMainNum(Integer examId, String subjectCode, boolean objective);

}
