package cn.com.qmth.stmms.biz.report.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Index;
import javax.persistence.Table;

import cn.com.qmth.stmms.common.annotation.ExcelField;

/**
 * 大题维度分析
 *
 * @author xuwenjin
 * @date 2019-04-12
 */
@Entity
@Table(name = "s_basic_group", indexes = { @Index(columnList = "exam_id,subject_code") })
public class ReportSubjectGroup implements Serializable {

    private static final long serialVersionUID = 3619846310455325739L;

    /**
     * 主键
     */
    @Id
    @GeneratedValue
    private Integer id;

    /**
     * 考试id
     */
    @Column(name = "exam_id")
    private Integer examId;

    /**
     * 课程编号
     */
    @ExcelField(title = "课程代码", align = 2, sort = 10)
    @Column(name = "subject_code")
    private String subjectCode;

    /**
     * 课程名称
     */
    @ExcelField(title = "课程名称", align = 2, sort = 20)
    @Column(name = "subject_name")
    private String subjectName;

    /**
     * 大题型
     */
    @ExcelField(title = "大题名称", align = 2, sort = 30)
    @Column(name = "group_name")
    private String groupName;

    /**
     * 大题号
     */
    @ExcelField(title = "大题号", align = 2, sort = 40)
    @Column(name = "group_number")
    private Integer groupNumber;

    /**
     * 最高分
     */
    @ExcelField(title = "最高分", align = 2, sort = 50)
    @Column(name = "max_score")
    private Double maxScore;

    /**
     * 最低分
     */
    @ExcelField(title = "最低分", align = 2, sort = 60)
    @Column(name = "min_score")
    private Double minScore;

    /**
     * 平均分
     */
    @ExcelField(title = "平均分", align = 2, sort = 70)
    @Column(name = "avg_score")
    private Double avgScore;

    /**
     * 满分
     */
    @ExcelField(title = "满分", align = 2, sort = 80)
    @Column(name = "total_score")
    private Double totalScore;

    /**
     * 标准差
     */
    @ExcelField(title = "标准差", align = 2, sort = 90)
    @Column(name = "sd")
    private Double SD;

    /**
     * 差异系数
     */
    @ExcelField(title = "差异系数(%)", align = 2, sort = 100)
    @Column(name = "cv")
    private Double CV;

    /**
     * 得分率
     */
    @ExcelField(title = "得分率", align = 2, sort = 110)
    @Column(name = "score_rate")
    private Double scoreRate;

    /**
     * 零分人数
     */
    @ExcelField(title = "零分人数", align = 2, sort = 120)
    @Column(name = "zero_count")
    private Integer zeroCount;

    /**
     * 满分人数
     */
    @ExcelField(title = "满分人数", align = 2, sort = 130)
    @Column(name = "full_count")
    private Integer fullCount;

    /**
     * 是否客观
     */
    @Column(name = "objective")
    private Boolean objective;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public Integer getExamId() {
        return examId;
    }

    public void setExamId(Integer examId) {
        this.examId = examId;
    }

    public String getSubjectCode() {
        return subjectCode;
    }

    public void setSubjectCode(String subjectCode) {
        this.subjectCode = subjectCode;
    }

    public String getSubjectName() {
        return subjectName;
    }

    public void setSubjectName(String subjectName) {
        this.subjectName = subjectName;
    }

    public String getGroupName() {
        return groupName;
    }

    public void setGroupName(String groupName) {
        this.groupName = groupName;
    }

    public Double getMaxScore() {
        return maxScore;
    }

    public void setMaxScore(Double maxScore) {
        this.maxScore = maxScore;
    }

    public Double getMinScore() {
        return minScore;
    }

    public void setMinScore(Double minScore) {
        this.minScore = minScore;
    }

    public Double getAvgScore() {
        return avgScore;
    }

    public void setAvgScore(Double avgScore) {
        this.avgScore = avgScore;
    }

    public Double getTotalScore() {
        return totalScore;
    }

    public void setTotalScore(Double totalScore) {
        this.totalScore = totalScore;
    }

    public Double getSD() {
        return SD;
    }

    public void setSD(Double sD) {
        SD = sD;
    }

    public Double getCV() {
        return CV;
    }

    public void setCV(Double cV) {
        CV = cV;
    }

    public Integer getZeroCount() {
        return zeroCount;
    }

    public void setZeroCount(Integer zeroCount) {
        this.zeroCount = zeroCount;
    }

    public Integer getFullCount() {
        return fullCount;
    }

    public void setFullCount(Integer fullCount) {
        this.fullCount = fullCount;
    }

    public Double getScoreRate() {
        return scoreRate;
    }

    public void setScoreRate(Double scoreRate) {
        this.scoreRate = scoreRate;
    }

    public Integer getGroupNumber() {
        return groupNumber;
    }

    public void setGroupNumber(Integer groupNumber) {
        this.groupNumber = groupNumber;
    }

    public Boolean getObjective() {
        return objective;
    }

    public void setObjective(Boolean objective) {
        this.objective = objective;
    }

}