package cn.com.qmth.stmms.biz.report.utils;

import java.util.LinkedList;
import java.util.List;

import cn.com.qmth.stmms.biz.exam.model.Exam;
import cn.com.qmth.stmms.biz.exam.model.ExamStudent;
import cn.com.qmth.stmms.biz.report.utils.module.SubjectClassModule;
import cn.com.qmth.stmms.biz.report.utils.module.SubjectCollegeModule;
import cn.com.qmth.stmms.biz.report.utils.module.SubjectModule;
import cn.com.qmth.stmms.biz.report.utils.module.SubjectTeacherClassModule;
import cn.com.qmth.stmms.biz.report.utils.module.SubjectTeacherModule;

public class ReportContext {

    private Exam exam;

    private List<Module> modules;

    public ReportContext(Exam exam) {
        this.exam = exam;
        this.modules = new LinkedList<Module>();

        this.modules.add(new SubjectModule(this));
        this.modules.add(new SubjectClassModule(this));
        this.modules.add(new SubjectCollegeModule(this));
        this.modules.add(new SubjectTeacherModule(this));
        this.modules.add(new SubjectTeacherClassModule(this));
    }

    public void process(ExamStudent student) {
        for (Module module : modules) {
            module.process(student);
        }
    }

    public void save() {
        for (Module module : modules) {
            module.save();
        }
    }

    public Double getPassScore() {
        return exam.getPassScore();
    }

    public Double getExcellentScore() {
        return exam.getExcellentScore();
    }

    public double getRangeInterval() {
        return 1;
    }

}
